; I-Ching Scripts for Jaws - By GDG&RA&JMFC

Include "hjconst.jsh"
include "Iching.jsm"

Const
IChingFile = "IChing.ini",
hexagrama="17_18_161190",
manual="Iching.txt"

globals
int estadomoneda,
handle window_were

Function AutoStartEvent()
SayFormattedMessage (Ot_Smart_help, "Pulse %KeyFor(help) para ayuda", "")
EndFunction

String Function jawsdirectory ()
VAR
String d,
string o,
string caracter,
int contador
let contador=1
let o=GetJAWSSettingsDirectory ()
While (contador<=StringLength (o))
let caracter=SubString (o, contador, 1)
If (caracter=="\\") then
let caracter="\\"+"\\"
EndIf
let d=d+caracter
let contador=contador+1
EndWhile
let d=d+"\\"+"\\"
return d

EndFunction

Void Function lanzaroparar ()
setFocus(FindDescendantWindow (getRealWindow(getfocus()), 4))
pause()
if (IsWindowDisabled (FindDescendantWindow (getRealWindow(getfocus()), 4))==false) then
typeKey("spaceBar")
else
return
EndIf
pause()
IF (estadomoneda==0) then
playsound(jawsdirectory()+"monedas.wav")


let estadomoneda=1
else 
playSound(JawsDirectory()+"parar.wav")
let estadomoneda=0
endif
EndFunction

Script lanzaryparar ()
var
handle Hwnd,
string str
let str="Moneda"
let Hwnd=getfocus()
if( contiene(hwnd, str)) then
lanzaroparar()
Else
TypeCurrentScriptKey ()
endif
EndScript

function WindowActivatedEvent(Handle Hwnd)
var
handle hwnd1
let estadomoneda=0
PAUSE()
SetJCFOption (OPT_SCREEN_ECHO, 1)
let hwnd1=GetFocus ()

if( contiene(hwnd1, "exagrama")) then
;StopSpeech ()
PAUSE()
;SayIchingButton(hwnd1)
/*
SaveCursor ()
RouteJAWSToPc ()
JAWSCursor ()
NextLine ()
;pause()
;StopSpeech ()
SayWindow (GetCurrentWindow(), 0)
RestoreCursor ()
*/
				SetJCFOption (OPT_SCREEN_ECHO, 2)
endIf
ScheduleFunction ("CompruebaVentanaMoneda", 5)
EndFunction

Int Function contiene (handle Hwnd, string str)
var		
int c
if (StringContains (GetWindowName (GetRealWindow (Hwnd)), str)) then
let c=1
EndIf
return c
EndFunction

String Function GetSectionName(Handle Hwnd)
Var
Handle r,
String s
Let r = GetRealWindow(Hwnd)
If r==0 Then
Let r = GetParent(Hwnd)
EndIf
If r==0 Then
Let r = GetAppMainWindow(Hwnd)
EndIf
Let s = GetWindowClass(r)
If s=="" Then
Let s = "NoClassName"
EndIf
Return s
EndFunction

String Function GetIdCode(Handle Hwnd)
Var
String s
Let s = IntToString(GetControlId(Hwnd))+"_"
Let s = s+ IntToString(GetControlId(GetNextWindow(Hwnd)))+"_"
Let s = s+ IntToString(GetControlId(GetPriorWindow(Hwnd)))
Let s = s+ IntToString(GetControlId(GetFirstWindow(Hwnd)))
Let s = s+ IntToString(GetControlId(GetLastWindow(Hwnd)))
Let s = s+ IntToString(GetControlId(GetParent(Hwnd)))
Return s
EndFunction

Void Function SayIChingButton(Handle Hwnd)
Var
String BName,
string MyCtrlName,
string MyName,
String RName
Let RName = GetSectionName(Hwnd)
Let BName = IniReadString(RName, GetIdCode(Hwnd), GetWindowName(Hwnd), IChingFile)
if (GetIdCode(Hwnd)==hexagrama) then
SetRestriction (3)
SaveCursor()
RouteInvisibleToPc ()
InvisibleCursor ()
NextLine ()
NextWord ()
NextWord()
let MyName=GetWord ()
restoreCursor()
EndIf
if (MyName=="PRINCIPAL") THEN
Let BName="Hexagrama complementario"
ElIf (MyName=="COMPLEMENTARIO") then
 let BName="Hexagrama Principal"
EndIf
if(not contiene(Hwnd, "Moneda")) then
	Say(BName+ " ", ot_no_disable)
If (contiene(hwnd, "Interpretacin del hexagrama") && GetControlID (Hwnd)<11 ) then
let MyCtrlName=""
Else
let MyCtrlName=GetWindowType (hwnd)
EndIf
saystring(myctrlname)
EndIf
EndFunction

Void Function FocusChangedEvent(Handle Hwnd, Handle Prev)
If (GetWindowSubTypeCode(Hwnd) == wt_button) Then
SayIChingButton(Hwnd)
Else
FocusChangedEvent(Hwnd, Prev)
EndIf
EndFunction



Script SetIChingButton ()
var
String RName,
String CName
If GetWindowSubTypeCode(GetCurrentWindow()) == wt_button Then
Let RName = GetSectionName(GetCurrentWindow())
Let CName = IniReadString(RName, GetIdCode(GetCurrentWindow()), "", IChingFile)
If InputBox("Inserte el texto del botn:", "Personalizar Botones", CName) Then
IniWriteString(RName, GetIdCode(GetCurrentWindow()), CName, IChingFile)
EndIf
EndIf
EndScript

Script salir ()
var
string str,
handle Hwnd
let Hwnd=getFocus()

let str="Monedas"
if( contiene(hwnd, str)) then
setFocus(FindDescendantWindow (getRealWindow(getfocus()), 23))
TypeKey("SpaceBar")
else
TypeCurrentScriptKey ()
EndIf
EndScript

Function CompruebaVentanaMoneda ()
if( contiene(GetFocus(), "Moneda") && GetControlID (Getfocus())!=0) then
SayFormattedMessage (Ot_JAWS_message, "pulse %KeyFor(lanzaryParar) para lanzar y parar o %KeyFor(salir) para salir", "")
EndIf
EndFunction


Script GotoEdit ()
var
handle hwnd,
string str
let hwnd=GetFocus()
let str="Interpretacin del hexagrama"
if (contiene(hwnd,str)) then
let window_were=GetFocus()

SaveCursor ()
RouteJAWSToPc ()
JAWSCursor ()
NextLine ()
LeftMouseButton ()
pause()
StopSpeech ()
SayWindow (GetCurrentWindow(), 0)
RestoreCursor ()
EndIf
EndScript

Script help ()
SayFormattedMessage (ot_User_buffer, msg_help, "")



EndScript


Script tab ()
If (window_were) then
SetFocus (window_were)
let window_were=StringToHandle ("")

EndIf
TypeCurrentScriptKey ()
EndScript


Script ShiftTab ()
If (window_were) then
SetFocus (window_were)
let window_were=StringToHandle ("")

EndIf
TypeCurrentScriptKey ()
EndScript


Script ReadINfo ()

var
int counter,
string str
SaveCursor ()

RouteJAWSToPc ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
NextLine ()
let counter=2

While (counter<9)
let str=str+GetLine ()+"\n"
NextLine ()
let counter=counter+1

EndWhile
RestoreCursor ()
SayMessage (ot_no_disable, str, "")
EndScript


Script ReadQuerry ()
var
int counter,
string str

SaveCursor ()
RouteJAWSToPc ()
JAWSCursor ()
JAWSPageUp ()
JAWSHome ()
let counter=1
While (counter<9)
NextLine ()
let counter=counter+1
EndWhile
let str=GetLine ()
RestoreCursor ()
SayMessage (ot_no_disable, "La consulta es: "+str, "")
EndScript


Script ReadManual ()

;SayMessage (ot_user_buffer,GetJAWSSettingsDirectory ()+"\\"+manual, "")

Run ("notepad "+GetJAWSSettingsDirectory ()+"\\"+manual)



EndScript

Script prueba ()
SayString (jawsdirectory())



EndScript
